/*
 *  mac.core 1.0
 */
var mac = {};
if (jQuery)
	(function() {
		jQuery.extend(jQuery.fn, {
			mac : function() {
				var func = arguments[0];
				arguments[0] = this;
				return eval('mac.' + func).apply(this, arguments);
			},
			seek : function(name) {
				return $(this).find('[name=' + name + ']');
			}
		});
	})(jQuery);
//
Number.prototype.to3ps = function(d){
	d = d || 0;
	var s = String(this.toFixed(d));
	var g = /(\d{1,3})(?=(\d{3})+$)/g;
	if(d<1)
		return s.replace(g, "$1,");
	var i = s.length-d;
	var p = s.substr(0, i-1);
	var x = s.substr(i);
	p = p.replace(g,"$1,");
	return p + '.' + x;
}
Date.prototype.format = function(format) {
	var o = {
		"M+" : this.getMonth() + 1,
		"d+" : this.getDate(),
		"h+" : this.getHours(),
		"m+" : this.getMinutes(),
		"s+" : this.getSeconds(),
		"q+" : Math.floor((this.getMonth() + 3) / 3),
		"S" : this.getMilliseconds()
	}
	if (/(y+)/.test(format))
		format = format.replace(RegExp.$1, (this.getFullYear() + "")
				.substr(4 - RegExp.$1.length));
	for ( var k in o)
		if (new RegExp("(" + k + ")").test(format))
			format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k]
					: ("00" + o[k]).substr(("" + o[k]).length));
	return format;
}
/**
 * 公用方法
 */
mac.eval = function(str) {
	if (str){
		return eval('(' + str + ')');
	}
	return { success : false };
};
mac.options = function(self, config) {
	self.empty();
	if (config == 'hour') {
		for ( var i = 0; i < 24; i++) {
			var h = (i > 9) ? i : '0' + i;
			jQuery('<option value="' + h + '">' + h + '</option>').appendTo(self);
		}
	} else if (config == 'min') {
		for ( var i = 0; i < 60; i++) {
			var m = (i > 9) ? i : '0' + i;
			jQuery('<option value="' + m + '">' + m + '</option>').appendTo(self);
		}
	}else{
		jQuery.each(config, function(i, n) {
			jQuery('<option value="' + i + '">' + n + '</option>').appendTo(self);
		});
	}
	return self;
};
mac.inputBox = function(label, callback, params, value){
	var b = jQuery('<div style="text-align: center; margin: 8px"></div>');
	var t = jQuery('<textarea></textarea>').width(320).height(80).append(value);
	var f = b.clone();
	var d = jQuery('<div></div>').dialog( {
		title: mac.getMsg(label, params),
		modal : true,
		width : 400,
		resizable : false,
		autoOpen : true
	}).append(b.append(t)).append(f);
	jQuery('<button name="ok">' + Msg.ok + '</button>').click(function(){
		d.dialog('close');
		callback(t.val());
	}).button().appendTo(f);
	jQuery('<button name="cancel">' + Msg.cancel + '</button>').click(function(){
		d.dialog('close');
	}).button().appendTo(f);
}
mac.getMsg = function(msg, params) {
	if (params && params.length)
		for ( var i = 0; i < params.length; i++)
			msg = msg.replace('{' + i + '}', params[i]);
	return msg;
};
mac.setLanguage = function(lan) {
	jQuery('.text').each(function(n, c) {
		var ec = $(c);
		var msg = ec.html();
		if (msg && msg.length > 4 && msg.substr(0, 4) == 'Msg.')
			ec.html(eval('(' + msg + ')'));
	});
};
/**
 * 一些组件
 */
// 默认的等待提示
mac.wait = function(msg, params) {
	var dlg = jQuery('<div><h3 align="center">' + mac.getMsg(msg, params) + '</h3></div>');
	dlg.dialog( {
		modal : true,
		resizable : false,
		width : 400,
		autoOpen : true,
		modal : true,
		beforeclose : function() {
			return false;
		}
	});
	return dlg;
};
// 对话框
mac.alert = function(msg, params) {
	var dlg = jQuery('<div><h3 align="center">' + mac.getMsg(msg, params) + '</h3></div>');
	var d = dlg.dialog( {
		modal : true,
		width : 400,
		resizable : false,
		autoOpen : true,
		buttons : {
			"确定" : function() {
				jQuery(this).dialog("close");
			}
		}
	});
	jQuery(document).keydown(function(e){
		switch(e.keyCode){
		case 13:
			d.dialog("close");
			break;
		case 27:
			d.dialog("close");
			break;
		}
	});
	return dlg;
};
// 确认框
mac.confirm = function(msg, callback, params, btns) {
	var dlg = jQuery('<div><h3 align="center">' + mac.getMsg(msg, params) + '</h3></div>');
	btns = btns || {
		"取消" : function() {
			jQuery(this).dialog("close");
		},
		"确定" : function() {
			jQuery(this).dialog("close");
			callback();
		}
	}
	var d = dlg.dialog( {
		modal : true,
		width : 400,
		resizable : false,
		autoOpen : true,
		buttons : btns
	});
	jQuery(document).keydown(function(e){
		switch(e.keyCode){
		case 13:
			callback();
			d.dialog("close");
			break;
		case 27:
			d.dialog("close");
			break;
		}
	});
	return dlg;
};
