/**
 *  version: 2.3.3
 *	author: Mac_J
 *	need: core.js
 */
mac.dtree = function(self, cfg) {
	self = jQuery.extend(self, cfg);
	var ldr = self.loader;
	ldr.params = ldr.params || {};
	self.rootNode = null;
	self.editingNode = null;
	self.setContextMenu = function() {
		if(!self.ctxMenu || self.ctxMenu.length!=1)
			return;
		var df = self.find('.ui-dynatree-document, .ui-dynatree-folder');
		df.contextMenu({
			menu : self.ctxMenu[0].id,
			onPopup : self.onCtxMenu,
			offset: self.menuOffset
		}, function(act, el, pos) {
			var dt = el.prop('dtnode');
			dt.activate(true);
			self.editingNode = dt;
			var mi = $.extend({
				'insert' : function(tree, dt, el, pos) {
					if (tree.doInsert)
						tree.doInsert(dt, tree.addNode);
				},
				'update' : function(tree, dt, el, pos) {
					if (tree.doUpdate)
						tree.doUpdate(dt, tree.updateNode);
				},
				'delete' : function(tree, dt, el, pos) {
					if (tree.doDelete)
						tree.doDelete(dt, function() {
							var tr = tree.dynatree('getTree')
							var pn = tr.getNodeByKey(dt.data.parent);
							if (pn) {
								pn.data.childCount--;
								if (pn.data.childCount == 0) {
									pn.data.isFolder = false;
									pn.data.isLazy = false;
								}
							}
							dt.remove();
						});
				}
			}, self.onCtxMIClick);
			mi[act](self, dt, el, pos);
		});
	};
	self.addNode = function(dd){
		var pn = self.getNode(dd.parent);
		if (pn == null || pn == undefined)
			return;
		pn.data.isFolder = true;
		pn.data.childCount++;
		pn.addChild(dd);
		pn.expand(true);
		self.setContextMenu();
	}
	self.updateNode = function(dd){
		self.editingNode.data = dd;
		$('#ui-dynatree-id-' + dd.key + ' a').text(dd.title);
		self.setContextMenu();
	}
	self.deleteNode = function(key){
		var pn = self.getNode(key);
		if(!pn)
			return;
		var pt = self.getNode(pn.data.parent);
		pt.data.childCount--;
		if (pt.data.childCount == 0) {
			pt.data.isFolder = false;
			pt.data.isLazy = false;
		}
		pn.remove();
	}
	self.deleteChildren = function(dt) {
		dt.visit(function(n){
			n.remove();
		});
		dt.data.isFolder = false;
		dt.data.isLazy = false;
		dt.data.childCount = 0;
	}
	self.loadSubTree = function(dt) {
		ldr.params.id = dt.data.key;
		ldr.params.level = dt.data.level;
		jQuery.post(ldr.url, ldr.params, function(data) {
			dt.setLazyNodeStatus(DTNodeStatus_Ok);
			var ro = mac.eval(data);
			dt.removeChildren();
			dt.addChild(ro.data);
			self.setContextMenu();
			if(self.onLoadSubTree)
				self.onLoadSubTree(ro.data);
		});
	};
	self.treeConfig = jQuery.extend({
		fx : {
			height : 'toggle',
			duration : 200
		},
		onLazyRead : function(dt) {
			self.loadSubTree(dt);
		},
		onClick : function(dt, event) {
			var a = self.ctxMenu;
			if (a && a.is(':visible') && a.css('display')!='none')
				return false;
			return true;
		},
		onActivate : function(dt) {
			if(self.ctxMenu && self.ctxMenu.length==1) {
				if (dt.data.childCount > 0)
					self.ctxMenu.disableContextMenu('#delete');
				if (dt.data.key == 'root')
					self.ctxMenu.disableContextMenu('#edit');
			}
			if(self.onActivate)
				self.onActivate(dt);
		}
	}, self.treeConfig);
	self.dynatree(self.treeConfig);
	self.getNode = function(k){
		return self.dynatree('getTree').getNodeByKey(k);
	}
	self.rootNode = self.dynatree("getRoot");
	self.rootNode.setLazyNodeStatus(DTNodeStatus_Loading);
	if(ldr.autoLoad)
		self.loadSubTree(self.rootNode);
	return self;
};
